// Generated by ReScript, PLEASE EDIT WITH CARE
'use strict';

var Curry = require("rescript/lib/js/curry.js");
var Belt_Array = require("rescript/lib/js/belt_Array.js");
var SchemaDrivenNamesCorrector = require("./SchemaDrivenNamesCorrector.bs.js");

function make(moduleName, t, struct) {
  return {
          moduleName: moduleName,
          t: t,
          struct: struct,
          moduleTypes: ["SchemaDrivenModule.SchemaDrivenModule with type t = " + SchemaDrivenNamesCorrector.modifyVariableName(moduleName)],
          funcDeclars: []
        };
}

function addModuleType(resultCodeDeclar, moduleType) {
  return {
          moduleName: resultCodeDeclar.moduleName,
          t: resultCodeDeclar.t,
          struct: resultCodeDeclar.struct,
          moduleTypes: Belt_Array.concat(resultCodeDeclar.moduleTypes, [moduleType]),
          funcDeclars: resultCodeDeclar.funcDeclars
        };
}

function filterModuleTypes(resultCodeDeclar, filter) {
  return {
          moduleName: resultCodeDeclar.moduleName,
          t: resultCodeDeclar.t,
          struct: resultCodeDeclar.struct,
          moduleTypes: resultCodeDeclar.moduleTypes.filter(Curry.__1(filter)),
          funcDeclars: resultCodeDeclar.funcDeclars
        };
}

function addFuncs(resultCodeDeclar, funcs) {
  return {
          moduleName: resultCodeDeclar.moduleName,
          t: resultCodeDeclar.t,
          struct: resultCodeDeclar.struct,
          moduleTypes: resultCodeDeclar.moduleTypes,
          funcDeclars: Belt_Array.reduce(funcs, resultCodeDeclar.funcDeclars, (function (acc, f) {
                  if (acc.includes(f)) {
                    return acc;
                  } else {
                    return Belt_Array.concat(acc, [f]);
                  }
                }))
        };
}

function printModuleBody(resultCodeDeclar) {
  return Belt_Array.concat([
                "type " + SchemaDrivenNamesCorrector.modifyVariableName(resultCodeDeclar.moduleName) + " = " + resultCodeDeclar.t + "",
                "type t = " + SchemaDrivenNamesCorrector.modifyVariableName(resultCodeDeclar.moduleName),
                "let struct: S.t<t> = " + resultCodeDeclar.struct
              ], resultCodeDeclar.funcDeclars).join("\n\n");
}

function printModuleType(resultCodeDeclar) {
  return "type " + SchemaDrivenNamesCorrector.modifyVariableName(resultCodeDeclar.moduleName) + " = " + resultCodeDeclar.t + "\n\n" + Belt_Array.map(resultCodeDeclar.moduleTypes, (function (t) {
                  return "include " + t;
                })).join("\n");
}

exports.make = make;
exports.addModuleType = addModuleType;
exports.filterModuleTypes = filterModuleTypes;
exports.addFuncs = addFuncs;
exports.printModuleBody = printModuleBody;
exports.printModuleType = printModuleType;
/* No side effect */
